/* Functions triggered by choosing 'Copy cheats to clipboard as...' with the desired emulator */


function downloadCheats(format) {
	// Format depends on the emulator used, so 1 function for each
	if (format === "text")
		downloadText();
	else if (format === "project64")
		downloadProject64();
	else if (format === "mupen64")
		downloadMupen64();
	else
		alert("Error: format unsupported.");

    return 0;
}

// For copying into a simple text file
function downloadText() {
	require(['jquery'], function($) { // Needs to use this stupid annonymous function through RequireJS. Blame XWiki for not being able to use JQuery globally...
		var file = "Dinosaur Planet\n\n\n";

		$(".code").each(function () {
			file += $(this).find(".name").text();

			file += "\n" + $(this).find(".gameshark").text();

			//Modifiers values
			if ( $(this).find(".values").length )
				file += "\n" + $(this).find(".values").text();

			if ( $(this).find(".note").length ) { // If a note exists
				file += "\nNote: ";
				if ( $(this).find(".description").length ) // If it's a long description
					file += $(this).find(".description").text(); // Replace long description's new lines with space
				else
					file += $(this).find(".note").attr("title");
			}

			file += "\n\n";
		});

		// Copy the text file to clipboard
		copyToClipboard($, file);
	});
}

// For Project64 2.4 and above
function downloadProject64() {
	require(['jquery'], function($) {
		var file = "[906C3F77-CE495EA1-C:45]\nName=DINO PLANET\n\n";

		$(".code:not(.ignore)").each(function () {
			file += "$"; // Each cheat starts with $
			file += $(this).parent().attr("name") + "\\";
			file += $(this).find(".name").text();

			if ( $(this).find(".note").length ) { // If a note exists
				file += "\nNote="
				if ( $(this).find(".description").length ) // If it's a long description
					file += $(this).find(".description").text().replace(/\n/g, " "); // Replace long description's new lines with space
				else
					file += $(this).find(".note").attr("title");
			}

			file += "\n" + $(this).find(".gameshark").text();

			//Modifiers values
			if ( $(this).find(".values").length ) {
				file += "\n" + $(this).find(".values").text();
			}

			file += "\n\n";
		});

		// Copy the text file to clipboard
		copyToClipboard($, file);
	});
}

// For RetroArch (based on Mupen64+)
function downloadMupen64() {
	require(['jquery'], function($) {
		var file = "";
		var i = 0;

		$(".code-block:not(.modifiers) .code").each(function () {
			file += 'cheat' + i + '_desc = "' + $(this).find(".name").text() + '"';
			file += '\ncheat' + i + '_code = "' + $(this).find(".gameshark").text().replace(/\n/g, "+") + '"'; // Replace new lines with +
			file += '\ncheat' + i + '_enable = "false"\n\n'; // Always disable cheats by default
			i++;
		});

		file += 'cheats = "' + i + '"'; // Add the number of current cheats at the end

		copyToClipboard($, file); // Copy the text file to clipboard
	});
}

/*
	Workaroud to copy a variable's content to clipboard by creating a textarea dom element,
	selecting it and then using the exec command 'copy' to copy to clipboard.
	*/
function copyToClipboard($, file) {
    var copieContent = $('<textarea>').val(file).appendTo('body').select();
    document.execCommand('copy');
    copyNotice();
}

// Might code a less annoying feedback function than an alert in the future...
function copyNotice() {
  alert("Content successfully copied to clipboard.");
}
